//
// Load a level
//
#include <cybiko.h>
#include "header.h"

struct Input *file_input;

void loadlevel(char *data,char *fn,char *mapname){
	int pos=0;
	char in;
	TRACE("Loading Level...");

	//Load the level
	file_input = open_resource_Ex(fn );

	if (Input_is_good (file_input)){
		TRACE("File : [%s]",fn);
		
		// get the map name
		do{
			in= Input_read_byte( file_input );  
			if (in>=32 && pos<25){mapname[pos++]=in;}
		}while(in>10);// enter is 10and/or13	
		
		mapname[pos]=0;
		TRACE("Name : [%s]",mapname);
		
		// load the actual map
		pos=0;
		do{
			in=Input_read_byte( file_input );   
			//ignore special characters
			if (in>=32){
				if (in<58){
					// turn "0" (char:48) into 0(char:0) 
					data[pos++]=in-48;
				}else{
					data[pos++]=in;
				}
			}
			
		}while(pos<(LEVELWIDTH*LEVELHEIGHT));	
			
		TRACE("Size : [%d]",pos);
	}else{
		TRACE("Error Loading Map: [%s]",fn);
	}
	Input_dtor( file_input, FREE_MEMORY );
}

