//
// Chuckie Egg for Cybiko by ssjx (2008)
//
//
// Make smallers swans - ?
// Make player sprite - smaller so he can jump
// Title screen
// Collecting + Scoring
// Level 2
// Web page
// 

#include <cybiko.h>
#include "header.h"

const char TITLE[]="Chuckie Egg";
const char URL[]="https://ssjx.co.uk";
const char VERSION[]="v0.2";

void loadlevel(char *,char *,char *);
void snapshot(char *);
int waitinput(struct module_t *);

void center(struct module_t *,char *,int );

//
//
//

struct module_t main_module;
struct DirectKeyboard *keys;

struct Input * ptr_input;
struct Bitmap bmp_brick,bmp_ladder,bmp_egg,bmp_seed,bmp_swan,bmp_swanl,bmp_player;

struct {
	char active;
	char sprite;
	short x;
	short y;
	short rx;
	short ry;

	char xdir;
	char ydir;
}nme[MAXSWANS];


void drawlevel(struct module_t *ptr_main_module,char *ar){
	int c=0;
	int i,j;
	for (j=0;j<LEVELHEIGHT;j++){
		for (i=0;i<LEVELWIDTH;i++){
			switch (ar[c])
			{
			case 1:
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_brick, i<<3, j<<3, BM_NORMAL );
			break;
			
			case 2:
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_ladder, i<<3, j<<3, BM_NORMAL );
			break;	
			
			case 3:
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_egg, i<<3, j<<3, BM_NORMAL );
			break;
			
			case 4:
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_seed, i<<3, j<<3, BM_NORMAL );
			break;
			}
			c++;
		}
	}
}


void setstart(char *ar,int *x,int *y){
	int i,j,c=0;

	for (j=0;j<LEVELHEIGHT;j++){
		for (i=0;i<LEVELWIDTH;i++){
			if (ar[c]==9){
				*x=i;
				*y=j;
				ar[c]=0;
				return;
			}
		c++;
		}
	}
}

int chk(char *map,int i,int j){
	return map[(LEVELWIDTH*j)+i];
}

void set(char *map,int i,int j,char c){
	map[(LEVELWIDTH*j)+i]=c;
}


int setswans(char *map){
	int i,j,c=0,nmecnt=0;
	
	for(i=0;i<MAXSWANS;i++){
		nme[i].active=0;
	}
	
	nmecnt=0;
	for (j=0;j<LEVELHEIGHT;j++){
		for (i=0;i<LEVELWIDTH;i++){
	
			if (map[c]==5){
				TRACE("Swan %d : %d x %d",nmecnt,i,j);
				nme[nmecnt].active=1;
				nme[nmecnt].sprite=5;
				nme[nmecnt].x=i;
				nme[nmecnt].y=j;
				nme[nmecnt].rx=i;
				nme[nmecnt].ry=j;
				nme[nmecnt].xdir=1;
				nme[nmecnt].ydir=0;
				map[c]=0;
				nmecnt++;
			}
			c++;
		}
	}
	TRACE("Swans : %d [%d]",nmecnt,c);
	return nmecnt;
}

// Count the number of eggs

int eggcount(char *ar){
	int cnt=0,c=0;

	for (c=0;c<LEVELHEIGHT*LEVELWIDTH;c++){
		if (ar[c]==3){cnt++;}
	}

	return cnt;
}


void centre(struct module_t *ptr_main_module,char *text,int y){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}

	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}

//char map[20][20];
     
long main(int argc, char *argv[],bool start){
	int i,j;
	int ext=0,jump=0,alt=0;
	char level_str[20];
	char *dis,*map;
	char mapname[30];

	int score=0,hiscore=10;
	char score_str[10];
	
	map=(char *)malloc(250); 

	TRACE("Chuckie Egg by ssjx");

	init_module( &main_module );

	//Graphics_set_font( main_module.m_gfx, mini_normal_font );
	dis=DisplayGraphics_get_page_ptr(main_module.m_gfx, 0);
	keys = DirectKeyboard_get_instance();
	
	//
	// Load our graphics
	//

	Bitmap_ctor(&bmp_brick);
	Bitmap_ctor(&bmp_ladder);
	Bitmap_ctor(&bmp_seed);
	Bitmap_ctor(&bmp_egg);
	Bitmap_ctor(&bmp_swan);
	Bitmap_ctor(&bmp_swanl);
	Bitmap_ctor(&bmp_player);
	
	ptr_input = open_resource_Ex( "brick.pic" );
	if (!Bitmap_load( &bmp_brick, ptr_input )){
		TRACE("Error loading brick");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	ptr_input = open_resource_Ex( "ladder.pic" );	
	if (!Bitmap_load( &bmp_ladder, ptr_input )){
		TRACE("Error loading ladder");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	ptr_input = open_resource_Ex( "egg.pic" );
	if (!Bitmap_load( &bmp_egg, ptr_input )){
		TRACE("Error loading egg");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	ptr_input = open_resource_Ex( "seed.pic" );
	if (!Bitmap_load( &bmp_seed, ptr_input )){
		TRACE("Error loading seed");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "swan-r1.pic" );
	if (!Bitmap_load( &bmp_swan, ptr_input )){
		TRACE("Error loading right swan");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "swan-l1.pic" );
	if (!Bitmap_load( &bmp_swanl, ptr_input )){
		TRACE("Error loading left swan");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "player-r1.pic" );
	if (!Bitmap_load( &bmp_player, ptr_input )){
		TRACE("Error loading player");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
		
	do{
		// Title Screen
		memset(dis,0,4000); // Clear screen
		
		TGraph_set_color( main_module.m_gfx, CLR_DKGRAY );
		
		centre( &main_module,"by ssjx",10);
		
		sprintf(score_str,"%d",hiscore);
		centre( &main_module, score_str,35);
		
		sprintf(score_str,"%d",score);
		centre( &main_module, score_str,55);
		
		TGraph_set_color( main_module.m_gfx, CLR_BLACK );
		
		centre( &main_module, TITLE, 1 );
		centre( &main_module, "High Score", 25 );
		centre( &main_module, "Previous Score", 45 );
		centre( &main_module, "Space = Start", 70 );
			
		//footer
		memset(dis+3560,0x55,440);
		TGraph_draw_line( main_module.m_gfx, 0, 88, 160, 88 );
		
		DisplayGraphics_draw_text( main_module.m_gfx, URL, 1, 90 );
		DisplayGraphics_draw_text( main_module.m_gfx, VERSION, 139, 90 );
		
		DisplayGraphics_show(main_module.m_gfx );


		ext=0;
		if (waitinput(&main_module)==KEY_ESC){
			TRACE("Escape from the title screen...");
			ext=2;
		}
			
		if (ext==0){	
			int level=1,lives=2;
			int x=5,y=5;
			int rx,ry;
			int eggs=0,nmecnt=0;
			int takeshot=0;
			
			// Load level from disk
			TRACE("Loading Level");
			loadlevel(map,"level1.ctd",mapname);

			// set up baddies
			nmecnt=setswans(map);
			TRACE("Swans: %d",nmecnt);

			eggs=eggcount(map);
			TRACE("eggs: %d",eggs);

			setstart(map,&x,&y);
			TRACE("Start: <%d , y%d>",x,y);
			rx=x;
			ry=y;
			// End of level loading

			// Slow! Does not need to be done each loop!
			sprintf(level_str,"Lvl: %d",level);
			sprintf(score_str,"Sc: %d",score);

			//draw level
			do{
				memset(dis,0,4000); // Clear bottom
				drawlevel(&main_module.m_gfx,map);
				center(&main_module,"Get Ready!",45);
				DisplayGraphics_show(main_module.m_gfx );
				waitinput(&main_module);
			
				do{
					memset(dis,0,4000); // Clear bottom
					ext=0;

					// Get Player Input
					DirectKeyboard_scan( keys );

					if ( DirectKeyboard_is_key_pressed( keys, KEY_SPACE ) ){
						ext=2;
					}
					
					if ( DirectKeyboard_is_key_pressed( keys, KEY_ESC ) ){
						TRACE("Escape pressed!");
						ext=2;
					}

					if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) ){
						if (chk(map,x,y)==2){
							y--;
						}
					}
					
					if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) ){
						if (chk(map,x,y+1)==2){
							y++;
						}	
					}

					if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) ){
						if (x!=0){x--;}
					}
					
					if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) ){
						if (x!=19){x++;}	
					}
					
					if ( DirectKeyboard_is_key_pressed( keys, KEY_H )  ){
						takeshot=1;
					}


					// Collect things
					switch (chk(map,x,y)){
						case 3:
							//egg
							score+=10;
							sprintf(score_str,"Sc: %d",score);
							set(map,x,y,0);
							eggs--;
						break;

						case 4:
							//seed
							score+=5;
							sprintf(score_str,"Sc: %d",score);
							set(map,x,y,0);
						break;
					}

					// falling
					if (chk(map,x,y+1)==0){
						y++;
					}

					// Update baddies ?
					for(i=0;i<MAXSWANS;i++){
						if (nme[i].active==1){
							if (alt==1){	
								//edge of the screen
								if (nme[i].x==0 || nme[i].x==19){
									nme[i].xdir=-nme[i].xdir;
								}else{	
									//edge of platform
									if (chk(map,nme[i].x+nme[i].xdir,nme[i].y+1)==0){
										nme[i].xdir=-nme[i].xdir;
									}
								}
								nme[i].x+=nme[i].xdir;
							}
							
							//swan hit player
							if (x==nme[i].x && y==nme[i].y){
								lives--;
								if (lives>0){ext=1;}else{ext=2;}
							}
						}
					}

					//
					// DRAW THE LEVEL
					//

					drawlevel(&main_module.m_gfx,map);

					// Draw baddies
					for(i=0;i<MAXSWANS;i++){
						if (nme[i].active==1){
							if (nme[i].xdir==1){
								Graphics_draw_bitmap(main_module.m_gfx, &bmp_swan, nme[i].x<<3, (nme[i].y<<3)-8, BM_NORMAL );
							}else{
								Graphics_draw_bitmap(main_module.m_gfx, &bmp_swanl, nme[i].x<<3, (nme[i].y<<3)-8, BM_NORMAL );
							}
						}
					}


					// Draw player
					Graphics_draw_bitmap(main_module.m_gfx, &bmp_player, x<<3, (y<<3), BM_NORMAL );

					// Draw status
					DisplayGraphics_draw_text( main_module.m_gfx, score_str, 1, 1 );
					DisplayGraphics_draw_text( main_module.m_gfx, level_str, 50, 1 );

					for(i=0;i<lives;i++){
						Graphics_draw_bitmap(main_module.m_gfx, &bmp_player, 151-(i<<3), 1, BM_NORMAL );
					}

					DisplayGraphics_show(main_module.m_gfx );

					// Take a snapshot after we have drawn everything
					if (takeshot==1){
						snapshot(dis);
						takeshot=0;
					}

					//
					sleep(100);
					alt=1-alt;

					//
					if (eggs==0){ext=3;}
				}while(ext==0);

				switch(ext){
					case 1:
						//lose a life - reset swans and player
						TRACE("Lost a life");
						for(i=0;i<MAXSWANS;i++){
							nme[i].x=nme[i].rx;
							nme[i].y=nme[i].ry;
						}
						x=rx;
						y=ry;
					break;

					case 2:
						//all lives lost...
						TRACE("Lost all lives..");
						center(&main_module,"Game Over",45);
						DisplayGraphics_show(main_module.m_gfx );
						waitinput(&main_module);
					break;

					case 3:
						TRACE("Next Level!");
						//next level
						level++;
						if (level>2){
							center(&main_module,"All Levels Completed!",45);
							DisplayGraphics_show(main_module.m_gfx );
							waitinput(&main_module);
						
							ext=2;
						}else{
							loadlevel(map,"level2.ctd",mapname);
							nmecnt=setswans(map);
							TRACE("Swans: %d",nmecnt);
							
							eggs=eggcount(map);
							TRACE("eggs: %d",eggs);
							
							setstart(map,&x,&y);
							TRACE("Start: <%d , y%d>",x,y);
							rx=x;
							ry=y;
						}
						sprintf(level_str,"Lvl: %d",level);
					break;
				}

			}while(ext!=2);
			ext=0;	// So we don't quit out of game!
		}
	}while(ext!=2);

	TRACE("Finished");

	DirectKeyboard_dtor( keys, FREE_MEMORY );
	Bitmap_dtor( &bmp_brick, LEAVE_MEMORY );
	Bitmap_dtor( &bmp_ladder, LEAVE_MEMORY );
	Bitmap_dtor( &bmp_egg, LEAVE_MEMORY );
	Bitmap_dtor( &bmp_seed, LEAVE_MEMORY );  
	Bitmap_dtor( &bmp_swan, LEAVE_MEMORY );
	Bitmap_dtor( &bmp_swanl, LEAVE_MEMORY );
	Bitmap_dtor( &bmp_player, LEAVE_MEMORY );  
	free(map);
	return 0L;
}
