//
// Standard useful functions
//

#include <cybiko.h>
#include "header.h"

void snapshot(char *);

//
//
//


int waitinput(struct module_t *ptr_main_module){
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0,exit=0;

	// Clear the message buffer of key downs presses
	while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYUP, MSG_KEYUP )){
		Message_delete( ptr_message );
		//	TRACE("Deleting message1");
	}
		 
	// Wait for a keypress
	do{
		ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
			
		if(ptr_message->msgid==MSG_KEYUP)
		{
		  ptr_key_param = Message_get_key_param( ptr_message );  
		  num=ptr_key_param->scancode;
		  exit=1;
		}    
		
		//cWinApp_defproc( ptr_main_module->m_process, ptr_message );
		Message_delete(ptr_message);
		ptr_message = NULL;

	}while(exit==0);

	return num;
}


//
//
//

void center(struct module_t *ptr_main_module,char *text,int y)
{
int width,pos;

width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );

pos=(160-width)>>1;	    
if (pos<0){pos=0;}

TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
TGraph_fill_rect(ptr_main_module->m_gfx,pos-5,y-5,width+10,20);

TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
TGraph_draw_rect(ptr_main_module->m_gfx,pos-5,y-5,width+10,20);

DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}


//
// Snapshot - Takes a screen grab and saves it as snapshot.pic
//

void snapshot(char *in)
{
struct FileOutput file_output;
long hd1,hd2;
char fn[30],i=0,exists=0;
FileOutput_ctor( &file_output );

hd1=0x0201a064;
hd2=0x0000a064;

do
{
	exists=0;
	memset(fn,0,sizeof(fn));
	sprintf(fn,"chuckie%d.pic",i);
	if( File_exists( fn )) {exists=1;i++;}
}while(exists==1);

if( FileOutput_open( &file_output, fn, TRUE ) )
{
FileOutput_write( &file_output,&hd1,4);
FileOutput_write( &file_output,&hd2,4);
FileOutput_write( &file_output,in,4000);
}

FileOutput_dtor( &file_output, LEAVE_MEMORY );
TRACE("Snapshot Taken, saved as %s",fn);
}
